#include "main.h"

#define APPNAME "MemoApp32"
#define VERSION "1.00"
#define BUILDDATE __DATE__" "__TIME__

#define MAINWNDCLASS "Memo32WndClass"
#define DUMMYWNDCLASS "Memo32ParentWndClass"
#define MEMOFILE "memo.dat"
#define WM_USER_TASKTRAY (WM_USER + 100)

HINSTANCE hInst = NULL;
HWND hMainWnd = NULL;
HWND hEditWnd = NULL;
HWND hTabWnd = NULL;

LPMEMOPAGE top = NULL;

int AddMemoPage(LPMEMOPAGE memo, int pos)
{
	LPMEMOPAGE cur, prev;
	int i;

	memo->next = NULL;	/* Ƃ肠B */

	if(top == NULL)
	{
		top = memo;

		return 0;
	}

	for(cur = top, prev = NULL, i = 0; cur->next && i != pos; prev = cur, cur = cur->next, i++);

	if(i == pos)
	{
		if(prev == NULL)
			top = memo;
		else
			prev->next = memo;
		memo->next = cur;
	}else	/* Ō */
	{
		cur->next = memo;
		for(cur = top, pos = 0; cur->next; cur = cur->next, pos++);
	}

	return pos;
}

DWORD fgetd(FILE* fp)
{
	DWORD d;

	fread(&d, sizeof(DWORD), 1, fp);

	return d;
}
void fputd(DWORD d, FILE* fp)
{
	fwrite(&d, sizeof(DWORD), 1, fp);

	return;
}

void Load(LPSETTINGS set)
{
	FILE* fp;
	int i;
	LPMEMOPAGE memo;

	ZeroMemory(set, sizeof(SETTINGS));

	if((fp = fopen(MEMOFILE, "rb")) == NULL)
	{
		RECT t = {CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT};
		set->wnd = t;

		return;
	}

	for(i = 0; ; i++)
	{
		int len;

		len = fgetd(fp);
		if(!len)	/* No more records. */
			break;

		if((memo = (LPMEMOPAGE)malloc(sizeof(MEMOPAGE))) == NULL)
			NotifyBox("Mallocing failed...but continue");

		ZeroMemory(memo, sizeof(MEMOPAGE));
		if((memo->title = (char*)malloc(len)) == NULL)
			NotifyBox("Mallocing failed...but continue");
		fread(memo->title, sizeof(char), len, fp);

		len = fgetd(fp);
		if(len)
		{
			if((memo->msg = (char*)malloc(len)) == NULL)
				NotifyBox("Mallocing failed...but continue");
			fread(memo->msg, sizeof(char), len, fp);
		}else
			memo->msg = NULL;

		memo->flag = fgetd(fp);

		AddMemoPage(memo, i);
	}
	set->lastsel = fgetd(fp);
	set->flat = fgetd(fp);
	set->wnd.left = fgetd(fp);
	set->wnd.top = fgetd(fp);
	set->wnd.right = fgetd(fp);
	set->wnd.bottom = fgetd(fp);

	fclose(fp);

	return;
}

void Save()
{
	FILE* fp;
	LPMEMOPAGE cur;
	RECT rc;

	//if(IsIconic(hMainWnd))	/* ŏ͖... */
	//	return;

	if((fp = fopen(MEMOFILE, "wb")) == NULL)
	{
		NotifyBox("FOPEN FAILED!!");
		return;
	}

	for(cur = top; cur; cur = cur->next)
	{
		fputd(strlen(cur->title) + 1, fp);
		fwrite(cur->title, sizeof(char), strlen(cur->title) + 1, fp);
		if(cur->msg)
		{
			fputd(strlen(cur->msg) + 1, fp);
			fwrite(cur->msg, sizeof(char), strlen(cur->msg) + 1, fp);
		}else
			fputd(0, fp);
		fputd(cur->flag, fp);
	}
	fputd(0, fp);
	fputd(TabCtrl_GetCurSel(hTabWnd), fp);
	if(GetWindowLong(hTabWnd, GWL_STYLE) & TCS_FLATBUTTONS)	/* ӂ */
		fputd(TRUE, fp);
	else
		fputd(FALSE, fp);
	if(IsIconic(hMainWnd))
	{
		int i;

		for(i = 0; i < 4; i++)
			fputd(-1, fp);
	}else
	{
		GetWindowRect(hMainWnd, &rc);
		fputd(rc.left, fp);
		fputd(rc.top, fp);
		fputd(rc.right - rc.left, fp);
		fputd(rc.bottom - rc.top, fp);
	}

	fclose(fp);

	return;
}

void ChangePage(int pos)
{
	int i;
	LPMEMOPAGE cur;

	if(!top)
		return;

	for(cur = top, i = 0; cur->next && i != pos; cur = cur->next, i++);

	if(!cur)
		NotifyBox("ȁANm˂̂܂ܘbBChangePageςȈŌĂ΂ꂽ񂾁B");

	TabCtrl_SetCurSel(hTabWnd, pos);
	SendMessage(hEditWnd, WM_SETTEXT, 0, (LPARAM)cur->msg);

	EnableWindow(hEditWnd, !(cur->flag & MPF_PROTECT));

	Save();

	return;
}

void RemakeTabs()
{
	TCITEM ti;
	LPMEMOPAGE cur = top;
	int i;
	int presel;

	presel = TabCtrl_GetCurSel(hTabWnd);

	TabCtrl_DeleteAllItems(hTabWnd);

	ti.mask = TCIF_TEXT;

	for(i = 0; cur; i++, cur = cur->next)
	{
		char tmp[256];

		ZeroMemory(tmp, 256);
		if(cur->flag & MPF_PROTECT)
			strcat(tmp, "*");
		strcat(tmp, cur->title);

		ti.pszText = tmp;
		TabCtrl_InsertItem(hTabWnd, i, &ti);
	}

	if(top)
		SetWindowLong(hEditWnd, GWL_STYLE, GetWindowLong(hEditWnd, GWL_STYLE) | WS_VISIBLE);
	else
		SetWindowLong(hEditWnd, GWL_STYLE, GetWindowLong(hEditWnd, GWL_STYLE) & ~WS_VISIBLE);

	if(presel == TabCtrl_GetItemCount(hTabWnd))
		ChangePage(presel - 1);
	else
		ChangePage(presel);

	InvalidateRect(hMainWnd, NULL, TRUE);

	return;
}

BOOL CALLBACK NameDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		SetDlgItemText(hWnd, IDC_NAME, (char*)lParam);
		break;
	case WM_CLOSE:
		EndDialog(hWnd, NULL);
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			{
				char* nm;
				int len = SendMessage(GetDlgItem(hWnd, IDC_NAME), WM_GETTEXTLENGTH, 0, 0);

				if(len == 0)
					MessageBox(hWnd, "͊ق", "Sorry.", MB_OK | MB_ICONERROR);
				else
				{
					if((nm = (char*)malloc(len + 1)) == NULL)
						NotifyBox("Mallocation failed...but continue.");
					GetDlgItemText(hWnd, IDC_NAME, nm, len + 1);
					EndDialog(hWnd, (int)nm);
				}
			}
			break;
		case IDCANCEL:
			PostMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		}
		break;
	default:
		return FALSE;
	}

	return TRUE;
}

void DeleteMemoPage(int pos)
{
	LPMEMOPAGE cur, prev;
	int i;

	if(!top)
		return;

	for(cur = top, prev = NULL, i = 0; cur->next && i != pos; prev = cur, cur = cur->next, i++);

	if(prev)
		prev->next = cur->next;
	else
		top = cur->next;

	if(cur->title)
		free(cur->title);
	if(cur->msg)
		free(cur->msg);
	free(cur);

	return;
}

LPMEMOPAGE GetMemoByIndex(int pos)
{
	int i;
	LPMEMOPAGE cur;

	for(cur = top, i = 0; cur->next && i != pos; cur = cur->next, i++);

	return cur;
}

int GetTCHit(HWND hWnd, POINT* pt)
{
	int i, act = -1, nums = TabCtrl_GetItemCount(hWnd);
	RECT rect;
	
	for(i = 0; i < nums; i++)
	{
		TabCtrl_GetItemRect(hWnd, i, &rect);
		if(IsPointInRect(pt, &rect))
		{
			act = i;
			break;
		}
	}

	return act;
}

/*
 * Tray(BOOL flag:True=In False=Out)
 */
void Tray(BOOL flag)
{
	NOTIFYICONDATA nid;

	ZeroMemory(&nid, sizeof(NOTIFYICONDATA));

	nid.cbSize = sizeof(NOTIFYICONDATA);
	nid.uID = 0;
	nid.hWnd = hMainWnd;

	if(flag)
	{
		nid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
		nid.hIcon = (HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_MAINWNDICON), IMAGE_ICON, 16, 16, 0);
		nid.uCallbackMessage = WM_USER_TASKTRAY;
		strcpy(nid.szTip, APPNAME);
		Shell_NotifyIcon(NIM_ADD, &nid);
	}else
	{
		Shell_NotifyIcon(NIM_DELETE, &nid);
	}
}

LRESULT CALLBACK MsgWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static WNDPROC prev;
	switch(msg)
	{
	case WM_USER:
		prev = (WNDPROC)lParam;
		break;
/*
	case WM_ERASEBKGND:
		{
			RECT rc;

			GetClientRect(hWnd, &rc);
			FillRect((HDC)wParam, &rc, GetSysColorBrush(COLOR_WINDOW));
		}
		return TRUE;
*/
	default:
		return CallWindowProc(prev, hWnd, msg, wParam, lParam);
	}

	return 0;
}

LRESULT CALLBACK TabWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static WNDPROC prev;

	switch(msg)
	{
	case WM_USER:
		prev = (WNDPROC)lParam;
		break;
	case WM_MBUTTONDOWN:
		{
			POINT pt;
			int act;

			pt.x = LOWORD(lParam);
			pt.y = HIWORD(lParam);
			//ScreenToClient(hTabWnd, &pt);

			act = GetTCHit(hTabWnd, &pt);

			if(act != -1)
			{
				DeleteMemoPage(act);
				RemakeTabs();

				Save();
			}
		}
		break;
	case WM_CONTEXTMENU:
		{
			HMENU pmnu, mnu;
			int i;
			int act = -1;
			POINT pt;

			pt.x = LOWORD(lParam);
			pt.y = HIWORD(lParam);
			ScreenToClient(hTabWnd, &pt);

			act = GetTCHit(hTabWnd, &pt);

			pmnu = LoadMenu(hInst, MAKEINTRESOURCE(IDR_POPUPMENU));
			mnu = GetSubMenu(pmnu, 0);

			/* :j[B */
			{
				MENUITEMINFO mii;

				mii.cbSize = sizeof(MENUITEMINFO);
				mii.fMask = MIIM_STATE;
				mii.fState = MFS_GRAYED;
				if(act == -1)
				{
					SetMenuItemInfo(mnu, ID_RENAME, FALSE, &mii);
					SetMenuItemInfo(mnu, ID_DELETE, FALSE, &mii);
					SetMenuItemInfo(mnu, ID_PROTECT, FALSE, &mii);
					SetMenuItemInfo(mnu, ID_MOVELEFT, FALSE, &mii);
					SetMenuItemInfo(mnu, ID_MOVERIGHT, FALSE, &mii);
				}else
				{
					if(GetMemoByIndex(act)->flag & MPF_PROTECT)
					{
						mii.fState = MFS_CHECKED;
						SetMenuItemInfo(mnu, ID_PROTECT, FALSE, &mii);

						mii.fState = MFS_GRAYED;
						SetMenuItemInfo(mnu, ID_RENAME, FALSE, &mii);
						SetMenuItemInfo(mnu, ID_DELETE, FALSE, &mii);
					}
					if(act == 0)
						SetMenuItemInfo(mnu, ID_MOVELEFT, FALSE, &mii);
					if(act == TabCtrl_GetItemCount(hTabWnd) - 1)
						SetMenuItemInfo(mnu, ID_MOVERIGHT, FALSE, &mii);
				}

			}
			/* ܂ */

			i = TrackPopupMenuEx(mnu, TPM_NONOTIFY | TPM_RETURNCMD, LOWORD(lParam), HIWORD(lParam), hWnd, NULL);

			DestroyMenu(mnu);
			DestroyMenu(pmnu);

			switch(i)
			{
			case ID_ADD:
				{
					char* nm;
					if(nm = (char*)DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_WHATSNAME), hMainWnd, NameDlgProc, NULL))
					{
						LPMEMOPAGE memo;
						int newpos;

						if((memo = (LPMEMOPAGE)malloc(sizeof(MEMOPAGE))) == NULL)
							NotifyBox("Mallocing failed...but continue");

						ZeroMemory(memo, sizeof(MEMOPAGE));
						memo->title = nm;

						newpos = AddMemoPage(memo, act);
						RemakeTabs();

						ChangePage(newpos);

						Save();
					}
				}
				break;
			case ID_RENAME:
				{
					char* nm;
					char* newnm;
					LPMEMOPAGE memo;

					memo = GetMemoByIndex(act);
					nm = memo->title;
					if(newnm = (char*)DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_WHATSNAME), hMainWnd, NameDlgProc, (LPARAM)nm))
					{
						memo->title = newnm;
						free(nm);
						RemakeTabs();

						Save();
					}
				}
				break;
			case ID_DELETE:
				{
					char str[1024];

					wsprintf(str, "\"%s\"\n\n폜Ăł?", GetMemoByIndex(act)->title);
					if(MessageBox(hWnd, str, "mF", MB_YESNO | MB_ICONQUESTION) == IDYES)
					{
						DeleteMemoPage(act);
						RemakeTabs();

						Save();
					}
				}
				break;
			case ID_MOVELEFT:
				{
					LPMEMOPAGE prev, cur;
					int sel = TabCtrl_GetCurSel(hTabWnd);

					prev = GetMemoByIndex(act - 1);
					cur = prev->next;

					prev->next = cur->next;
					cur->next = prev;

					if(act == 1)
						top = cur;
					else
						GetMemoByIndex(act - 2)->next = cur;

					if(act - 1 == sel)
						sel = act;
					else if(act == sel)
						sel = act - 1;

					RemakeTabs();
					ChangePage(sel);
				}
				break;
			case ID_MOVERIGHT:
				{
					LPMEMOPAGE cur, next;
					int sel = TabCtrl_GetCurSel(hTabWnd);

					cur = GetMemoByIndex(act);
					next = cur->next;

					cur->next = next->next;
					next->next = cur;

					if(act == 0)
						top = next;
					else
						GetMemoByIndex(act - 1)->next = next;

					if(act == sel)
						sel = act + 1;
					else if(act + 1 == sel)
						sel = act;

					RemakeTabs();
					ChangePage(sel);
				}
				break;
			case ID_PROTECT:
				if(GetMemoByIndex(act)->flag & MPF_PROTECT)
					GetMemoByIndex(act)->flag &= ~MPF_PROTECT;
				else
					GetMemoByIndex(act)->flag |= MPF_PROTECT;

				RemakeTabs();
				break;
			}
		}
		break;
	default:
		return CallWindowProc(prev, hWnd, msg, wParam, lParam);
	}

	return 0;
}

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_CREATE:
		{
			HMENU hSysMenu = GetSystemMenu(hWnd, FALSE);
			HMENU hPMnu, hMnu;
			int i;

			hPMnu = LoadMenu(hInst, MAKEINTRESOURCE(IDR_POPUPMENU));
			hMnu = GetSubMenu(hPMnu, 2);

			for(i = 0; i < GetMenuItemCount(hMnu); i++)
			{
				MENUITEMINFO mii;
				char tmp[256];

				ZeroMemory(&mii, sizeof(MENUITEMINFO));
				mii.cbSize = sizeof(MENUITEMINFO);
				mii.fMask = MIIM_ID | MIIM_STATE | MIIM_TYPE;
				mii.fType = MFT_STRING;
				mii.dwTypeData = tmp;
				mii.cch = 255;
				if(!GetMenuItemInfo(hMnu, i, /*byIndex*/TRUE , &mii))
					ShowLastError();
				InsertMenuItem(hSysMenu, GetMenuItemCount(hSysMenu) - 1, /*byIndex*/TRUE, &mii);
			}

			DestroyMenu(hMnu);
			DestroyMenu(hPMnu);

			InsertMenu(hSysMenu, GetMenuItemCount(hSysMenu) - 1, MF_BYPOSITION | MF_SEPARATOR, 0, NULL);
		}
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	/*
	case WM_NCHITTEST:
		wParam = DefWindowProc(hWnd, msg, wParam, lParam);
		if(wParam == HTCLIENT)
			return HTCAPTION;
		else
			return wParam;
		break;
	*/
	case WM_MOVE:
		Save();
		break;
	case WM_SIZE:
		{
			RECT rect;

			if(wParam == SIZE_MINIMIZED)
			{
				ShowWindow(hMainWnd, SW_HIDE);
				Tray(TRUE);

				Save();
			}else
			{
				GetClientRect(hWnd, &rect);
				SetWindowPos(hTabWnd, 0, 0, 0, rect.right, 23, SWP_NOZORDER);
				SetWindowPos(hEditWnd, 0, 0, 23, rect.right, rect.bottom - 23, SWP_NOZORDER);

				Save();
			}
		}
		break;
	case WM_NOTIFY:
		{
			LPNMHDR	nmh = (LPNMHDR)lParam;

			switch(nmh->code)
			{
			case TCN_SELCHANGE:
				if(nmh->hwndFrom == hTabWnd)
					ChangePage(TabCtrl_GetCurSel(hTabWnd));
				break;
			}
		}
		break;
	case WM_CONTEXTMENU:
		{
			POINT pt = {LOWORD(lParam), HIWORD(lParam)};
			RECT rc;

			GetWindowRect(hTabWnd, &rc);
			if(IsPointInRect(&pt, &rc))
				TabWndProc(hTabWnd, WM_CONTEXTMENU, wParam, lParam);
			else
				DefWindowProc(hWnd, msg, wParam, lParam);
		}
		break;
	case WM_INITMENUPOPUP:
		if(HIWORD(lParam))	/* Is this SystemMenu? */
		{
			HMENU hSysMenu = (HMENU)wParam;//GetSystemMenu(hWnd, FALSE);
			MENUITEMINFO mii;

			ZeroMemory(&mii, sizeof(MENUITEMINFO));
			mii.cbSize = sizeof(MENUITEMINFO);
			mii.fMask = MIIM_STATE;
			if(!GetMenuItemInfo(hSysMenu, ID_FLAT, /*byIndex*/FALSE , &mii))
				ShowLastError();
			if(GetWindowLong(hTabWnd, GWL_STYLE) & TCS_FLATBUTTONS)	/* ӂ */
				mii.fState |= MFS_CHECKED;
			else
				mii.fState &= ~MFS_CHECKED;
			if(!SetMenuItemInfo(hSysMenu, ID_FLAT, /*byIndex*/FALSE, &mii))
				ShowLastError();
		}

		break;
	case WM_SYSCOMMAND:
		switch(wParam)
		{
		case ID_VERSION:
			PostMessage(hWnd, WM_COMMAND, ID_VERSION, 0);
			break;
		case ID_FLAT:
			if(GetWindowLong(hTabWnd, GWL_STYLE) & TCS_FLATBUTTONS)	/* ӂ */
			{
				SetWindowLong(hTabWnd, GWL_STYLE, GetWindowLong(hTabWnd, GWL_STYLE) & ~TCS_FLATBUTTONS & ~TCS_BUTTONS & ~TCS_HOTTRACK);
				TabCtrl_SetExtendedStyle(hTabWnd, TabCtrl_GetExtendedStyle(hTabWnd) & ~TCS_EX_FLATSEPARATORS);
			}else	/* ܂ӂƂȂ */
			{
				SetWindowLong(hTabWnd, GWL_STYLE, GetWindowLong(hTabWnd, GWL_STYLE) | TCS_FLATBUTTONS | TCS_BUTTONS | TCS_HOTTRACK);
				TabCtrl_SetExtendedStyle(hTabWnd, TabCtrl_GetExtendedStyle(hTabWnd) | TCS_EX_FLATSEPARATORS);
			}

			Save();
			break;
		case ID_DELETEALL:
			if(MessageBox(hWnd, "Delete all, OK?", "Confirm", MB_ICONERROR | MB_YESNO) == IDYES)
			{
				int i;

				for(i = 0; i < TabCtrl_GetItemCount(hTabWnd); i++)
					DeleteMemoPage(0);

				RemakeTabs();
				Save();
			}
			break;
		default:
			return DefWindowProc(hWnd, msg, wParam, lParam);
		}
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case ID_RESTORE:
			Tray(false);
			ShowWindow(hMainWnd, SW_RESTORE);
			//ShowWindow(hMainWnd, SW_SHOW);
			SetForegroundWindow(hMainWnd);
			SetFocus(hMainWnd);
			Save();
			break;
		case ID_VERSION:
			MessageBox(hWnd, APPNAME" ver"VERSION"\nby Murachue\n\nBuild date:"BUILDDATE, "MemoApp32", MB_OK | MB_ICONINFORMATION);
			break;
		case ID_QUIT:
			Tray(FALSE);
			PostMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		}

		switch(HIWORD(wParam))
		{
		case EN_CHANGE:
			{
				LPMEMOPAGE memo = GetMemoByIndex(TabCtrl_GetCurSel(hTabWnd));
				int len = SendMessage(hEditWnd, WM_GETTEXTLENGTH, 0, 0) + 1;

				if(memo->msg)
				{
					if((memo->msg = (char*)realloc(memo->msg, len)) == NULL)
						NotifyBox("reallocation failed,but continue.");
				}else{
					if((memo->msg = (char*)malloc(len)) == NULL)
						NotifyBox("mallocation failed,but continue.");
				}
				SendMessage(hEditWnd, WM_GETTEXT, len, (LPARAM)memo->msg);

				Save();
			}
			break;
		}
		break;
	case WM_USER_TASKTRAY:
		switch(lParam)
		{
		case WM_LBUTTONDBLCLK:
			PostMessage(hWnd, WM_COMMAND, ID_RESTORE, 0);
			break;
		case WM_RBUTTONUP:
			{
				HMENU hSubMenu, hPMenu;
				POINT pt;

				GetCursorPos(&pt);

				hPMenu = LoadMenu(hInst, MAKEINTRESOURCE(IDR_POPUPMENU));
				hSubMenu = GetSubMenu(hPMenu, 1);
				SetMenuDefaultItem(hSubMenu, ID_RESTORE, FALSE);

				SetForegroundWindow(hWnd);

				TrackPopupMenuEx(hSubMenu, 0, pt.x, pt.y, hWnd, NULL);
				DestroyMenu(hSubMenu);
				DestroyMenu(hPMenu);

				PostMessage(hWnd, WM_NULL, 0, 0);
			}
			break;
		}
		break;
	default:
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}

	return 0;
}

LRESULT CALLBACK DummyWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{

	switch(msg)
	{
	case WM_ACTIVATE:
		SetActiveWindow(hMainWnd);
		break;
	case WM_SIZE:
		break;
	default:
		return MainWndProc(hMainWnd, msg, wParam, lParam);
	}
	return 0;
}

BOOL InitClass()
{
	WNDCLASS wc;
	int result = 0;

	wc.style			= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc		= MainWndProc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hInstance		= hInst;
	wc.hIcon			= 
		/*
		(HICON)LoadIcon(hInst, MAKEINTRESOURCE(IDI_MAINICON));//*/
		//*
		(HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_MAINWNDICON), IMAGE_ICON, 16, 16, 0);//*/
	wc.hCursor			= (HCURSOR)LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)GetSysColorBrush(COLOR_3DFACE);/*GetStockObject(WHITE_BRUSH);*/
	wc.lpszMenuName		= NULL;
	wc.lpszClassName	= (LPCTSTR)MAINWNDCLASS;
	result |= !RegisterClass(&wc);/* !0=TRUE=ERROR */

	wc.lpfnWndProc		= DummyWndProc;
	wc.lpszClassName	= (LPCTSTR)DUMMYWNDCLASS;
	result |= !RegisterClass(&wc);/* !0=TRUE=ERROR */

	return result;
}

BOOL InitWindow(LPSETTINGS set)
{
	RECT rc = set->wnd;
	HWND hWndtmp;

	hWndtmp = CreateWindow(MAINWNDCLASS, "Memo_Parent", WS_OVERLAPPEDWINDOW,
							0, 0, 0, 0,
							NULL, (HMENU)NULL, hInst, 0);
	//ShowWindow(hWndtmp, SW_NORMAL);
	if(rc.left == -1)
		hMainWnd = CreateWindow(MAINWNDCLASS, "Memo", WS_OVERLAPPEDWINDOW,
								CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
								hWndtmp, (HMENU)NULL, hInst, 0);
	else
		hMainWnd = CreateWindow(MAINWNDCLASS, "Memo", WS_OVERLAPPEDWINDOW,
								rc.left, rc.top, rc.right, rc.bottom,
								hWndtmp, (HMENU)NULL, hInst, 0);
	hTabWnd = CreateWindowEx(0, WC_TABCONTROL, "", WS_CHILD | WS_VISIBLE,
							CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
							hMainWnd, (HMENU)0, hInst, 0);
	hEditWnd = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | ES_MULTILINE | ES_AUTOVSCROLL | ES_AUTOHSCROLL | ES_WANTRETURN,
							CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
							hMainWnd, (HMENU)0, hInst, 0);

	SendMessage(hTabWnd, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), MAKELPARAM(1, 0));
	SendMessage(hEditWnd, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), MAKELPARAM(1, 0));

	SendMessage(hEditWnd, EM_SETMARGINS, (WPARAM)EC_LEFTMARGIN, (LPARAM)MAKELONG(3, 0));

	TabWndProc(hTabWnd, WM_USER, 0, GetWindowLong(hTabWnd, GWL_WNDPROC));
	SetWindowLong(hTabWnd, GWL_WNDPROC, (LONG)TabWndProc);

	MsgWndProc(hEditWnd, WM_USER, 0, GetWindowLong(hEditWnd, GWL_WNDPROC));
	SetWindowLong(hEditWnd, GWL_WNDPROC, (LONG)MsgWndProc);

	return FALSE;
}

void freeall()
{
	LPMEMOPAGE cur, next;

	for(cur = top; cur; )
	{
		if(cur->title)
			free(cur->title);
		if(cur->msg)
			free(cur->msg);

		next = cur->next;
		free(cur);
		cur = next;
	}
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
	MSG msg;
	SETTINGS set;

	hInst = hInstance;	/* 傗YĂ */

	InitCommonControls();
	if(InitClass())
		NotifyBox("uhawwwokwww errorwwww");
	Load(&set);
	InitWindow(&set);
	RemakeTabs();
	ChangePage(set.lastsel);
	if(set.flat)
	{
		SetWindowLong(hTabWnd, GWL_STYLE, GetWindowLong(hTabWnd, GWL_STYLE) | TCS_FLATBUTTONS | TCS_BUTTONS | TCS_HOTTRACK);
		TabCtrl_SetExtendedStyle(hTabWnd, TabCtrl_GetExtendedStyle(hTabWnd) | TCS_EX_FLATSEPARATORS);
	}

	if(set.wnd.left == -1)
	{
		ShowWindow(hMainWnd, SW_MINIMIZE);
		Tray(TRUE);
	}else
	{
		ShowWindow(hMainWnd, nShowCmd);
		UpdateWindow(hMainWnd);
	}

	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	freeall();

	return 0;
}
